+++
title = "Links Comentados de 2020-07-12"
date = 2020-07-12

[taxonomies]
tags = ["links", "erlang", "acessibilidade", "stackoverflow", "testes",
"flexbox", "c", "http", "servidor"]
+++

Erlang por Exemplos, Acessibilidade, Boas Respostas no StackOverflow, Testes,
Flexbox, Servidor HTTP in C, Sorvete Afetando Carros.

<!-- more -->

## [Erlang/OTP by Example](http://erlangbyexample.org/)

Erlang esta na minha lista de linguagens que eu quero aprender e ter um "Por
Exemplos" sempre ajuda -- pelo menos, me ajudou um monte com Rust.

## [The 6 Most Common Accessibility Problems (and How to Fix Them)](https://blog.scottlogic.com/2020/07/02/6-most-common-accessibility-problems.html)

Acessibilidade é sempre importante. E saber que tem algo parecido com o OWASP
(que mantém uma lista de falhas de segurança de aplicações web) que tem uma
lista de problemas comuns sempre ajuda. E, ainda por cima, tendo uma lista de
problemas simples e fáceis de serem resolvidos é sempre melhor.

## [Parsing city of origin / destination city from a string](https://stackoverflow.com/questions/59956670/parsing-city-of-origin-destination-city-from-a-string)

Embora a resposta seja bem longa e não um simples "Use X", esse é o tipo de
resposta que o StackOverflow deveria ter: Mesmo que a pergunta pareça absurda,
tem uma longa explicação de como fazer, cada passo e cada problema com cada
passo até o ponto de "não é assim tão simples".

## [against testing](https://flak.tedunangst.com/post/against-testing)

Alguém levou o que eu falei sobre testes muuuito a sério.

Ok, testar tudo parece errado, mas você pode ver que as coisas estão erradas
quando alguém diz que "Os testes são frágeis, quebrando devido a alterações
completamente inócuas no código". Aqui é onde está o problema: Você é um
idiota se isso acontece; você deveria estar testando _comportamentos_, não
implementações. É óbvio que o teste vai ser frágil porque você está testando a
coisa de forma errada.

Isso é um dos pontos que eu realmente não gosto dos chamados "testes de
unitários" -- no sentido de "testar cada função". Comportamento não está
contido em apenas uma função, mas surge quando as funções interagem. É por
isso que testes de integração parecem mais "corretos" pra mim: Nós ignoramos
como as coisas foram implementadas e focamos em como o sistema deve se
comportar.

Então sim, testar está errado e você não gosta disso, especialmente quando
você está escrevendo os testes da forma errada pra inicio de conversa.

## [Coping with flexbox](https://kgrz.io/coping-with-flexbox.html)

Flexbox é a nova coisa legal em desenvolvimento web atualmente, principalmente
porque corrige o maldito problema de "centralizar o conteúdo verticalmente e
horizontalmente". E esse tipo de explicação, que começa no básico, sempre
ajuda.

## [httpserver.h:  Single header library for writing non-blocking HTTP servers in C](https://github.com/jeremycw/httpserver.h)

Uma coisas coisas estranhas de C é que você pode fazer basicamente tudo,
incluindo escrever um servidor HTTP não blocando em apenas um arquivo.

## ["My Car does not start when I buy Vanilla Ice Cream", said a Man to General Motors.](https://www.digitalrepublik.com/digital-marketing-newsletter/2015/05/10/my-car-does-not-start-when-i-buy-vanilla-ice-cream-said-a-man-to-general-motors/)

Eu adoro esse tipo de história: Coisas que não funcionam porque algo
completamente randômico e aparentemente não relacionado aconteceu.

Me lembra da história de "Minha senha não funciona quando eu fico em pé".

<!-- 
vim:spelllang=pt:
-->
