+++
title = "Learning Java - Patrick Niemeyer"
date = 2018-08-03
updated = 2021-02-12

[taxonomies]
tags = ["books", "patrick niemeyer", "reviews", "java", "it", "stars:2",
"published:2005"]
+++

[GoodReads Summary](https://www.goodreads.com/book/show/665984.Learning_Java):
Version 5.0 of the Java 2 Standard Edition SDK is the most important upgrade
since Java first appeared a decade ago. With Java 5.0, you'll not only find
substantial changes in the platform, but to the language itself-something that
developers of Java took five years to complete. The main goal of Java 5.0 is
to make it easier for you to develop safe, powerful code, but none of these
improvements makes Java any easier to learn, even if you've programmed with
Java for years. And that means our bestselling hands-on tutorial takes on even
greater significance."Learning Java" is the most widely sought introduction to
the programming language that's changed the way we think about computing. Our
updated third edition takes an objective, no-nonsense approach to the new
features in Java 5.0, some of which are drastically different from the way
things were done in any previous versions. The most essential change is the
addition of "generics," a feature that allows developers to write, test, and
deploy code once, and then reuse the code again and again for different data
types. The beauty of generics is that more problems will be caught during
development, and "Learning Java" will show you exactly how it's done.Java 5.0
also adds more than 1,000 new classes to the Java library. That means 1,000
new things you can do without having to program it in yourself. That's a huge
change. With our book's practical examples, you'll come up to speed quickly on
this and other new features such as loops and threads. The new edition also
includes an introduction to Eclipse, the open source IDE that is growing in
popularity. "Learning Java," 3rd Edition addresses all of the important uses
of Java, such as web applications, servlets, and XML that are increasingly
driving enterprise applications.

<!-- more -->

{{ stars(stars=2) }}

I once said that it's not just the matter of wanting to learn something, there
is also the matter of wanting to *teach*.

The problem here is that the book doesn't seem interested in the second.

I mean, sure, it's nice that you go through *all* the classes, but... is it
necessary? Is this teaching? Not to me.

Either focus on how things work and how to pick things, but going over and
over and over over *everything* is tiring and not helpful. Not to mention
there is a lot of things said twice (or even more), which seems focused on
making the book bigger, instead of making things clearer.
